/* This software is contributed or developed by KYOCERA Corporation.
   (C) 2011 KYOCERA Corporation  */

#ifdef CONFIG_WIFI_CONTROL_FUNC
#include <linux/platform_device.h>
#endif
#include <typedefs.h>
#include <linuxver.h>
#include <osl.h>

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/random.h>
#include <linux/spinlock.h>
#include <linux/ethtool.h>
#include <linux/fcntl.h>
#include <linux/fs.h>

#include <asm/uaccess.h>
#include <asm/unaligned.h>

#include <epivers.h>
#include <bcmutils.h>
#include <bcmendian.h>

#include <proto/ethernet.h>
#include <dngl_stats.h>
#include <dhd.h>
#include <dhd_bus.h>
#include <dhd_proto.h>
#include <dhd_dbg.h>

#include <dhd_kyocera.h>

int chk_wifi_macaddr(char *filename)
{
    char mac_format[MAC_FORMAT_SIZE]={'m','a','c','a','d','d','r','='};
    unsigned int  len      = 0;
    unsigned char read_buf = 0;
    void          * image  = NULL;
    unsigned int  cnt      = 0;
    unsigned char mac_cnt  = 0;
    int ret                = 0;
    unsigned char find_mac_format = 0;
    unsigned char read_addr[ADDR_FORMAT_SIZE];

    memset(read_addr,0,ADDR_FORMAT_SIZE);

    image = dhd_os_open_image(filename);
    if (image == NULL)
    {
        printk("nvram.txt is none\n");
        return ret;
    }

    for(cnt = 0; cnt < NVRAM_TXT_READ_DATA_SIZE; cnt++)
    {
        len = dhd_os_get_image_block(&read_buf, 1, image);
        if(len > 0)
        {
            if(read_buf == mac_format[mac_cnt])
            {
                if(mac_cnt >= MAC_FORMAT_SIZE -1)
                {
                    find_mac_format = 1;
                    mac_cnt = 0;
                    break;
                }
                else
                {
                    mac_cnt++;
                }
            }
            else
            {
                mac_cnt = 0;
            }
        }
        else
        {
            printk("read fin\n");
            break;
        }
    }
    if(find_mac_format == 1){
        len = dhd_os_get_image_block(read_addr, ADDR_FORMAT_SIZE, image);

        if(len == ADDR_FORMAT_SIZE){
            if( (chk_hex_ascii(read_addr[0]) != 0) &&
                (chk_hex_ascii(read_addr[1]) != 0) &&
                (read_addr[2]  == ':') &&
                (chk_hex_ascii(read_addr[3]) != 0) &&
                (chk_hex_ascii(read_addr[4]) != 0) &&
                (read_addr[5]  == ':') &&
                (chk_hex_ascii(read_addr[6]) != 0) &&
                (chk_hex_ascii(read_addr[7]) != 0) &&
                (read_addr[8]  == ':') &&
                (chk_hex_ascii(read_addr[9]) != 0) &&
                (chk_hex_ascii(read_addr[10]) != 0) &&
                (read_addr[11] == ':') &&
                (chk_hex_ascii(read_addr[12]) != 0) &&
                (chk_hex_ascii(read_addr[13]) != 0) &&
                (read_addr[14] == ':') &&
                (chk_hex_ascii(read_addr[15]) != 0) &&
                (chk_hex_ascii(read_addr[16]) != 0)
            ){
                if(!(( read_addr[0]  == '0') &&
                     ( read_addr[1]  == '0') &&
                     ( read_addr[3]  == '0') &&
                     ( read_addr[4]  == '0') &&
                     ( read_addr[6]  == '0') &&
                     ( read_addr[7]  == '0') &&
                     ( read_addr[9]  == '0') &&
                     (read_addr[10]  == '0') &&
                     (read_addr[12]  == '0') &&
                     (read_addr[13]  == '0') &&
                     (read_addr[15]  == '0') &&
                     (read_addr[16]  == '0')
                )){
                    ret = 1;
                }
            }
        }
    }
    dhd_os_close_image(image);
    return ret;
}
int chk_hex_ascii(char chk_data)
{
    int ret = 0;

    switch(chk_data)
    {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'a':
    case 'A':
    case 'b':
    case 'B':
    case 'c':
    case 'C':
    case 'd':
    case 'D':
    case 'e':
    case 'E':
    case 'f':
    case 'F':
        ret = 1;
        break;
    default:
        break;
    }
    return ret;
}
